//
// 1.          
// 2.   ShiftPendingOrders,         
// 3.   4-  5-
//
// VAY loopsidery@yahoo.com
//
//+------------------------------------------------------------------+
//|                                                e-News-Lucky$.mq4 |
//|                                                   Lucky$ & KimIV |
//|                                              http://www.kimiv.ru |
//|                                                                  |
//|      http://fxmail.ru/soft/       |
//|                                                                  |
//| 24.10.2005                                                       |
//|        .    |
//|      ,     .   |
//+------------------------------------------------------------------+
#property copyright "Lucky$ & KimIV & VAY"
#property link      "http://www.kimiv.ru"
#define   MAGIC     20051024

//-------    --------------------------------
extern string _Parameters_Trade = "-----  ";
extern double Lots           = 0.1;     //   
extern int    StopLoss       = 15;      //   
extern int    TakeProfit     = 0;       //   
extern int    DistanceSet    = 20;      //   
extern bool   ShiftPendingOrders = True; //     ,   
extern bool   UseTrailing    = True;    //  
extern bool   ProfitTrailing = True;    //   
extern int    TrailingStop   = 25;      //   
extern int    TrailingStep   = 5;       //  
extern int    Slippage       = 3;       //  

extern string _Parameters_Time = "-----  ";
extern bool AUTO = TRUE; //     
extern string _x1 = "-----  AUTO == TRUE ";
extern int GMToffset=3; // 
extern int MinBeforeSet = 15;  //   
extern int MinAfterDel = 60;  //   
extern int MinAfterClose = 60;  //   
extern string _x2 = "-----  AUTO == FALSE ";
extern string TimeSetOrders  = "10:30"; //   
extern string TimeDelOrders  = "22:30"; //   
extern string TimeClosePos   = "22:30"; //   

extern string _Parameters_Expert = "-----  ";
extern string Name_Expert   = "e-News-Lucky$";
extern bool   UseSound      = True;         //   
extern string NameFileSound = "expert.wav"; //   
extern color  clOpenBuy     = LightBlue;    //   
extern color  clOpenSell    = LightCoral;   //   
extern color  clModifyBuy   = Aqua;         //   
extern color  clModifySell  = Tomato;       //   
extern color  clCloseBuy    = Blue;         //   
extern color  clCloseSell   = Red;          //   
int fl=0;
//----    -------------------------------
int prevBar;
bool ACTIVE = FALSE;
int TimeActualNews;
double point4;

int init() {
   if (Digits < 4) {
      point4 = 0.01;
   } else {
      point4 = 0.0001;
   }
   return(0);
}

void deinit() {
  Comment("");
}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
void start() {
   if (AUTO) {
      int TimeNextNews = iCustom(NULL, 0, "Urdala_News", GMToffset, true, false, false, true, false, Red, Blue, Lime, 2, 0, 0);
      if (TimeNextNews >= TimeCurrent() + MinBeforeSet*60 && TimeNextNews < TimeCurrent() + 24*3600 && !ACTIVE) {
         ACTIVE = TRUE;
         TimeActualNews = TimeNextNews;
         TimeSetOrders = TimeToStr(TimeActualNews - MinBeforeSet*60, TIME_MINUTES);
         TimeDelOrders = TimeToStr(TimeActualNews + MinAfterDel*60, TIME_MINUTES);
         TimeClosePos = TimeToStr(TimeActualNews + MinAfterClose*60, TIME_MINUTES);
      }

         //   
      string info = "\n\n\n";
      int TimeLeft = TimeActualNews - TimeCurrent();
      if (ACTIVE) {
         info = info + "Time of the actual news: " + TimeToStr(TimeActualNews, TIME_DATE|TIME_MINUTES) + "\n";
         info = info + "TimeSetOrders = " + TimeSetOrders + "\n";
         info = info + "TimeDelOrders = " + TimeDelOrders + "\n";
         info = info + "TimeClosePos = " + TimeClosePos + "\n";
         info = info + "Time left = " + TimeToStr(TimeLeft, TIME_MINUTES) + "\n";
      } else {
         info = info + "No actual news found \n";
      }
      Comment(info);

      if (ACTIVE && TimeCurrent() > TimeActualNews && !ExistOrder(1) && !ExistOrder(2)) {
         ACTIVE = FALSE;  //    
      }

      if (!ACTIVE) return;
   }

   if (TimeToStr(CurTime(), TIME_MINUTES)==TimeSetOrders) SetOrders();
   if (ShiftPendingOrders && prevBar!=Bars && ExistOrder(1) && ExistOrder(2)) ModifyOrders();
   DeleteOppositeOrders();
   TrailingPositions();
   if (TimeToStr(CurTime(), TIME_MINUTES)==TimeDelOrders) DeleteAllOrders();
   if (TimeToStr(CurTime(), TIME_MINUTES)==TimeClosePos) CloseAllPositions();
   prevBar=Bars;
}

//+------------------------------------------------------------------+
//|                                                  |
//+------------------------------------------------------------------+
void SetOrders() {
  double ldStop=0, ldTake=0;
  int    spr=MarketInfo(Symbol(), MODE_SPREAD);
  double pAsk=Ask+DistanceSet*point4+spr*Point;
  double pBid=Bid-DistanceSet*point4;

  if (!ExistOrder(1)) {
    if (StopLoss!=0) ldStop=pAsk-StopLoss*point4;
    if (TakeProfit!=0) ldTake=pAsk+TakeProfit*point4;
    SetOrder(OP_BUYSTOP, pAsk, ldStop, ldTake, 1);
  }
  if (!ExistOrder(2)) {
    if (StopLoss!=0) ldStop=pBid+StopLoss*point4;
    if (TakeProfit!=0) ldTake=pBid-TakeProfit*point4;
    SetOrder(OP_SELLSTOP, pBid, ldStop, ldTake, 2);
  }
}

//+------------------------------------------------------------------+
//|                                                |
//+------------------------------------------------------------------+
void ModifyOrders() {
  bool   fm;
  double ldStop=0, ldTake=0;
  int    spr=MarketInfo(Symbol(), MODE_SPREAD);
  double pAsk=Ask+DistanceSet*point4+spr*Point;
  double pBid=Bid-DistanceSet*point4;

  for (int i=0; i<OrdersTotal(); i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC+1) {
        if (StopLoss!=0) ldStop=pAsk-StopLoss*point4;
        if (TakeProfit!=0) ldTake=pAsk+TakeProfit*point4;
        OrderModify(OrderTicket(), pAsk, ldStop, ldTake, 0, clModifyBuy);
      }
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC+2) {
        if (StopLoss!=0) ldStop=pBid+StopLoss*point4;
        if (TakeProfit!=0) ldTake=pBid-TakeProfit*point4;
        OrderModify(OrderTicket(), pBid, ldStop, ldTake, 0, clModifySell);
      }
    }
  }
}

//+------------------------------------------------------------------+
//|               |
//+------------------------------------------------------------------+
bool ExistOrder(int mn) {
  bool Exist=False;
  for (int i=0; i<OrdersTotal(); i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC+mn) {
        Exist=True; break;
      }
    }
  }
  return(Exist);
}

//+------------------------------------------------------------------+
//|                        |
//+------------------------------------------------------------------+
bool ExistPosition(int mn) {
  bool Exist=False;
  for (int i=0; i<OrdersTotal(); i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC+mn) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          Exist=True; break;
        }
      }
    }
  }
  return(Exist);
}

//+------------------------------------------------------------------+
//|                                                   |
//| :                                                       |
//|   op     -                                               |
//|   pp     -                                                   |
//|   ldStop -                                            |
//|   ldTake -                                            |
//|   mn     -   MAGIC                                      |
//+------------------------------------------------------------------+
void SetOrder(int op, double pp, double ldStop, double ldTake, int mn) {
  color  clOpen;
  string lsComm=GetCommentForOrder();

  if (op==OP_BUYSTOP) clOpen=clOpenBuy;
  else clOpen=clOpenSell;
  OrderSend(Symbol(),op,Lots,pp,Slippage,ldStop,ldTake,lsComm,MAGIC+mn,0,clOpen);
  if (UseSound) PlaySound(NameFileSound);
}

//+------------------------------------------------------------------+
//|          |
//+------------------------------------------------------------------+
string GetCommentForOrder() {
  return(Name_Expert);
}

//+------------------------------------------------------------------+
//|                                               |
//+------------------------------------------------------------------+
void DeleteAllOrders() {
  bool fd;int fl=0;
  for (int i=OrdersTotal()-1; i>=0; i--) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderMagicNumber()>MAGIC && OrderMagicNumber()<=MAGIC+2) {
        if (OrderSymbol()==Symbol()) {
          if (OrderType()==OP_BUYSTOP || OrderType()==OP_SELLSTOP) {
            fd=OrderDelete(OrderTicket());
            if (fd && UseSound) PlaySound(NameFileSound);
          }
        }
      }
    }
  }
}

//+------------------------------------------------------------------+
//|                                 |
//+------------------------------------------------------------------+
void CloseAllPositions() {
  bool fc;fl=0;
  for (int i=OrdersTotal()-1; i>=0; i--) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderMagicNumber()>MAGIC && OrderMagicNumber()<=MAGIC+2) {
        if (OrderSymbol()==Symbol()) {
          fc=False;
          if (OrderType()==OP_BUY) {
            fc=OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, clCloseBuy);
          }
          if (OrderType()==OP_SELL) {
            fc=OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, clCloseSell);
          }
          if (fc && UseSound) PlaySound(NameFileSound);
        }
      }
    }
  }
}

//+------------------------------------------------------------------+
//|                                    |
//+------------------------------------------------------------------+
void DeleteOppositeOrders() {
  bool fd, fep1, fep2;

  fep1=ExistPosition(1);
  fep2=ExistPosition(2);

  for (int i=OrdersTotal()-1; i>=0; i--) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symbol()) {
        fd=False;
        if (OrderType()==OP_BUYSTOP && OrderMagicNumber()==MAGIC+1) {
          if (fep2) fd=OrderDelete(OrderTicket());
        }
        if (OrderType()==OP_SELLSTOP && OrderMagicNumber()==MAGIC+2) {
          if (fep1) fd=OrderDelete(OrderTicket());
        }
        if (fd && UseSound) PlaySound(NameFileSound);
      }
    }
  }
}

//+------------------------------------------------------------------+
//|                                 |
//+------------------------------------------------------------------+
void TrailingPositions() {
  for (int i=0; i<OrdersTotal(); i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderMagicNumber()>MAGIC && OrderMagicNumber()<=MAGIC+2) {
        if (OrderSymbol()==Symbol()) {
          if (OrderType()==OP_BUY) {
            if (!ProfitTrailing || (Bid-OrderOpenPrice())>TrailingStop*point4) {
              if (OrderStopLoss()<Bid-(TrailingStop+TrailingStep-1)*point4) {
                ModifyStopLoss(Bid-TrailingStop*point4, clModifyBuy);
              }
            }
          }
          if (OrderType()==OP_SELL) {
            if (!ProfitTrailing || OrderOpenPrice()-Ask>TrailingStop*point4) {
              if (OrderStopLoss()>Ask+(TrailingStop+TrailingStep-1)*point4 || OrderStopLoss()==0) {
                ModifyStopLoss(Ask+TrailingStop*point4, clModifySell);
              }
            }
          }
        }
      }
    }
  }
}

//+------------------------------------------------------------------+
//|   StopLoss                                          |
//| :                                                       |
//|   ldStopLoss -  StopLoss                                  |
//|   clModify   -                                    |
//+------------------------------------------------------------------+
void ModifyStopLoss(double ldStop, color clModify) {
  bool   fm;
  double ldOpen=OrderOpenPrice();
  double ldTake=OrderTakeProfit();

  fm=OrderModify(OrderTicket(), ldOpen, ldStop, ldTake, 0, clModify);
  if (fm && UseSound) PlaySound(NameFileSound);
}
//+------------------------------------------------------------------+

